{*******************************************************}
{                                                       }
{                      RSDBNavigator                    }
{                                                       }
{        Copyright (c) 2000, 2001 by RealSoft           }
{	 	    E-mail & http:			}
{          dclrs@realsoft2000.virtualave.net            }
{*******************************************************}
unit RSDBNavigator;

interface

{$R *.dcr}
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, DB, DBCtrls, RSControls, RXCtrls;
type


 { TRSNavigator }
  TPropButton = (btFirst,btPrev,btNext,btLast,btEdit,btAdd,btDel,btApply,
                  btCancel,btRefresh);
  TPropButtons = Set of TPropButton;
  ENavClick = procedure (Sender: TObject; Button: TPropButton) of object;
  ENavBClick = procedure (Sender: TObject; Button: TPropButton; Var Exec:boolean) of object;

  TRSNavDataLink = class;

  TRSDBNavigator = class(TRSPanel)
  private
   FDataSource: TRSNavDataLink;
   FButtons : array [TPropButton] of TRxSpeedButton;
   FOnNavClick: ENavClick;
   FBeforeAction: ENavBClick;
   FConfirmDelete: Boolean;
   FFlat : Boolean;
   FBtWidth : integer;
   FBtHeight : integer;
   FTransparent: Boolean;
   FImages: TImageList;
   FNames: TStringList;
   FsCaptions: Boolean;
   FASize: Boolean; // AutoSize
   FPButtons : TPropButtons;
   FNumGlyphs: Integer;
    { Private declarations }
  protected
    { Protected declarations }
   procedure WMGetDlgCode(var Message: TWMGetDlgCode); message WM_GETDLGCODE;
   procedure CMEnabledChanged(var Message: TMessage); message CM_ENABLEDCHANGED;
   procedure WMSize (var Message: TWMSize); message WM_Size;
   procedure SetDataSource (Value: TDataSource);
   function GetDataSource: TDataSource;
   procedure SetFlat (Value: Boolean);
   procedure SetTransparent (Value: Boolean);
   procedure SetImages (Value: TImageList);
   procedure SetNames (Value: TStringList);
   procedure SetWidth (Value: Integer);
   procedure SetHeight (Value: Integer);
   procedure SetCaptions (Value: Boolean);
   procedure SetAutoSize (Value: Boolean);
   procedure SetNumGlyphs (Value: Integer);
   procedure SetButtons (Value: TPropButtons);
   procedure UpdateCaptions;
//   procedure UpdateSize;
   procedure UpdateButtons;
   function  GetMaxLenCaption: integer;
   function  GetMaxHeight: integer;
   procedure ClickHandler(Sender: TObject);
   procedure DataChanged;
   procedure EditingChanged;
   procedure ActiveChanged;
   procedure Loaded; override;
   procedure Notification(AComponent: TComponent;
      Operation: TOperation); override;

  public
    { Public declarations }
   constructor Create (AOwner: TComponent); override;
   procedure CreateParams (Var Params: TCreateParams); override;
   destructor Destroy; override;
   procedure BtnClick(Index: TPropButton); virtual;
published
    { Published declarations }
   property DataSource: TDataSource read GetDataSource write SetDataSource;
   property Glyphs: TImageList read FImages write SetImages;
   property Flat: Boolean read FFlat write SetFlat;
   property Names: TStringList read FNames write SetNames;
   property BtHeight: integer read FBtHeight write SetHeight;
   property BtWidth: integer read FBtWidth  write SetWidth;
   property Transparent: Boolean read FTransparent write SetTransparent;
   property ShowCaptions: Boolean read FsCaptions write SetCaptions;
   property Buttons: TPropButtons read FPButtons write SetButtons
            default [btFirst,btPrev,btNext,btLast,btEdit,btAdd,btDel,btApply,
                  btCancel,btRefresh];
   property AutoSize: Boolean read FASize write SetAutoSize;
   property ConfirmDelete: Boolean read FConfirmDelete write FConfirmDelete default True;
   property BeforeAction: ENavBClick read FBeforeAction write FBeforeAction;
   property OnClick: ENavClick read FOnNavClick write FOnNavClick;
   property NumGlyphs: integer read FNumGlyphs  write SetNumGlyphs default 1;

end;
{ TRSNavDataLink }

  TRSNavDataLink = class(TDataLink)
  private
    FNavigator: TRSDBNavigator;
  protected
    procedure EditingChanged; override;
    procedure DataSetChanged; override;
    procedure ActiveChanged; override;
  public
    constructor Create(ANav: TRSDBNavigator);
    destructor Destroy; override;
  end;


procedure Register;

implementation

Const
 rsMargin=10;
 rsHMargin=8;
Var
BtName: array[TPropButton] of string = ('', '', '',
    '', '', '', '', '', '', '');
oldWidth,oldHeight :integer;

procedure Register;
begin
  RegisterComponents('RS Control', [TRSDBNavigator]);
end;

procedure TRSDBNavigator.CreateParams (Var Params: TCreateParams);
Begin
 inherited CreateParams(Params);
 Params.Caption :='';
End;

procedure TRSDBNavigator.WMSize (Var Message: TWMSize);
begin
 inherited;
 Height := FBtHeight+4;
 UpdateButtons;
// Width := 10*FBtWidth+4;
end;

constructor TRSDBNavigator.Create (AOwner : TComponent);
Var
 i:TPropButton;
 lft:integer;
begin
 inherited Create (AOwner);
 FNames := TStringList.Create;
 FDataSource := TRSNavDataLink.Create (Self);
 FFlat := false;
 FsCaptions := true;
 For i:=Low(FButtons) to High(FButtons) do
   FNames.Add (BtName[i]);
 FBtWidth := 50;
 FBtHeight := 40;
 OldWidth := FBtWidth;
 OldHeight := FBtHeight;
 FASize := false;
 Width := 4;
 lft:=2;
 FNumGlyphs :=1;
 FConfirmDelete:=true;
 FPButtons :=[btFirst,btPrev,btNext,btLast,btEdit,btAdd,btDel,btApply,
                  btCancel,btRefresh];
 For i:=Low(FButtons) to High(FButtons) do
  Begin
   FButtons[i] := TRxSpeedButton.Create (Self);
   FButtons[i].Parent := Self;
   FButtons[i].Left := lft;
   FButtons[i].Top := 2;
   FButtons[i].Height := FBtHeight;
   FButtons[i].Width := FBtWidth;
   FButtons[i].Caption := BtName[i];
   FButtons[i].Visible := i in FPButtons;
   FButtons[i].OnClick := ClickHandler;
   FButtons[i].NumGlyphs := FNumGlyphs;
   lft := lft + FButtons[i].Width;
  End;
 Height := FBtHeight+4;
 Width := 10*FBtWidth+4;
end;

destructor TRSDBNavigator.Destroy;
Var
 idx : TPropButton;
begin
 For idx:=Low(FButtons) to High(FButtons) do
  FButtons[idx].Free;
 FDataSource.Free;
 FNames.Free;
 inherited Destroy;
end;

procedure TRSDBNavigator.SetDataSource (Value: TDataSource);
begin
 FDataSource.DataSource := Value;
 if not (csLoading in ComponentState) then
   ActiveChanged;
 if Value <> nil then Value.FreeNotification(Self);
end;

function TRSDBNavigator.GetDataSource: TDataSource;
begin
 Result := FDataSource.DataSource;
end;

procedure TRSDBNavigator.SetFlat (Value: Boolean);
Var
 idx:TPropButton;
Begin
 if Value <> FFlat then
  Begin
   For idx:=Low(FButtons) to High(FButtons) do
    FButtons[idx].Flat := Value;
  FFlat := Value;
  End;
End;

procedure TRSDBNavigator.SetTransparent (Value: Boolean);
Var
 idx:TPropButton;
Begin
 if Value <> FTransparent then
  Begin
 For idx:=Low(FButtons) to High(FButtons) do
    FButtons[idx].Transparent := Value;
  FTransparent := Value;
  End;
End;

procedure TRSDBNavigator.SetImages (Value: TImageList);
Var
 idx:TPropButton;
 id:integer;
Begin
 if FImages <> nil then
  For idx:=Low(FButtons) to High(FButtons) do
   Begin
    FButtons[idx].Glyph.Height := 0;
    FButtons[idx].Glyph.Width := 0;
   End;

 FImages:=Value;

 if FImages <> nil then
  Begin
  id:=0;
  For idx:=Low(FButtons) to High(FButtons) do
   Begin
    FImages.GetBitmap (Id,FButtons[idx].Glyph);
    FButtons[idx].NumGlyphs := FNumGlyphs;
    inc (id);
   End;
  End;
 SetAutoSize (FASize);
End;

procedure TRSDBNavigator.SetNames (Value: TStringList);
Begin
 FNames.Assign (Value);
 UpdateCaptions;
End;

procedure TRSDBNavigator.SetWidth (Value: Integer);
Begin
 if not FASize then
  Begin
   FBtWidth := Value;
  End else
   Begin
    FBtWidth := GetMaxLenCaption + rsMargin;
   End;
 UpdateButtons;
 OldWidth := FBtWidth;
End;

procedure TRSDBNavigator.SetHeight (Value: Integer);
Begin
 if not FASize then
  Begin
   FBtHeight := Value;
  End else
   Begin
    FBtHeight := GetMaxHeight + rsHMargin;
   End;
UpdateButtons;
OldHeight := FBtHeight;
End;

procedure TRSDBNavigator.SetCaptions (Value: Boolean);
Var
 idx:TPropButton;
Begin
 FsCaptions := Value;
 if FsCaptions=true then
  Begin
   UpdateCaptions;
   FBtWidth := OldWidth;
   FBtHeight := OldHeight;
   SetAutoSize (FASize);
  End else
  Begin
   OldWidth := FBtWidth;
   OldHeight := FBtHeight;
   FBtWidth := 25;
   FBtHeight := 25;
   if Assigned (FImages) then
    Begin
     FBtWidth := (FImages.Width div FNumGlyphs)+rsMargin;
     FBtHeight := FImages.Height+rsMargin;
    End;
   For idx:=Low(FButtons) to High(FButtons) do
    FButtons[idx].Caption := '';
   SetAutoSize (FASize);
  End;
 UpdateButtons;
End;

function TRSDBNavigator.GetMaxLenCaption: integer;
Var
 idx:integer;
Begin
 Result := 0;
 if FsCaptions=true then
  For idx:=0 to 9 do
   if (Length(FNames[idx])<>0) and (Canvas.TextWidth (FNames[idx])>Result) then
     Result := Canvas.TextWidth (FNames[idx]);
 if Assigned (FImages) then
  if FImages.Width div FNumGlyphs > Result then
   Result := FImages.Width div FNumGlyphs;
End;

function TRSDBNavigator.GetMaxHeight: integer;
Var
 idx:integer;
Begin
 Result := 0;
 if FsCaptions=true then
  For idx:=0 to 9 do
   if (Length(FNames[idx])<>0) and (Canvas.TextHeight (FNames[idx])>Result) then
     Result := Canvas.TextHeight (FNames[idx]);
 if Assigned (FImages) then
  Result := Result + FImages.Height;
End;


procedure TRSDBNavigator.UpdateCaptions;
Var
 idx:TPropButton;
 id:integer;
Begin
 idx:=btFirst;
 if Assigned (FNames) then
 For id:=0 to FNames.Count-1 do
  if Length(FNames[id])<>0 then
   Begin
    FButtons[idx].Caption := FNames[id];
    inc (idx);
   End;
End;
{
procedure TRSDBNavigator.UpdateSize;
Var
 idx:TPropButton;
Begin
 For idx:=Low(FButtons) to High(FButtons) do
  Begin
   FButtons[idx].Height := FBtHeight;
   FButtons[idx].Width := FBtWidth;
  End;
  UpdateButtons;
End;
}
procedure TRSDBNavigator.SetAutoSize (Value: Boolean);
Begin
 FASize := Value;
 if (csLoading in ComponentState) then Exit;
 if FASize =true then
  Begin
   FBtWidth := GetMaxLenCaption + rsMargin;
   FBtHeight := GetMaxHeight + rsHMargin;
   UpdateButtons;
  End;
End;

procedure TRSDBNavigator.SetButtons (Value: TPropButtons);
var
  I: TPropButton;
begin
  FPButtons := Value;
  for I := Low(FButtons) to High(FButtons) do
    FButtons[I].Visible := I in FPButtons;
  UpdateButtons;
  Invalidate;
end;

procedure TRSDBNavigator.UpdateButtons;
var
  idx: TPropButton;
  lft: integer;
begin
 if (csLoading in ComponentState) then Exit;
  lft :=2;
  for Idx := Low(FButtons) to High(FButtons) do
   Begin
    FButtons[Idx].SetBounds (lft,2,FBtWidth,FBtHeight);
    if FButtons[Idx].Visible then
      lft := lft+FBtWidth;
   End;
 Height := FBtHeight+4;
 if Align= alNone then
  Width := lft+4;
end;
////////////////////////////////////////////
procedure TRSDBNavigator.ClickHandler(Sender: TObject);
var
  idx: TPropButton;
begin
  for Idx := Low(FButtons) to High(FButtons) do
    if TRxSpeedButton (Sender)=FButtons[Idx] then
     BEgin
      BtnClick (Idx);
      Exit;
     End;
end;

procedure TRSDBNavigator.BtnClick(Index: TPropButton);
var
 rez:boolean;
begin
 rez:=true;
 if not (csDesigning in ComponentState) and Assigned(FBeforeAction) then
    FBeforeAction(Self, Index, rez);
  if (DataSource <> nil) and (DataSource.State <> dsInactive) and (rez=true) then
  begin
    with DataSource.DataSet do
    begin
      case Index of
        btPrev: Prior;
        btNext: Next;
        btFirst: First;
        btLast: Last;
        btAdd: Insert;
        btEdit: Edit;
        btCancel: Cancel;
        btApply: Post;
        btRefresh: Refresh;
        btDel:
          if not FConfirmDelete or
            (MessageDlg('   ?', mtConfirmation,
            mbOKCancel, 0) <> idCancel) then Delete;
      end;
    end;
  end;
  if not (csDesigning in ComponentState) and Assigned(FOnNavClick) then
    FOnNavClick(Self, Index);
end;

procedure TRSDBNavigator.WMGetDlgCode(var Message: TWMGetDlgCode);
begin
  Message.Result := DLGC_WANTARROWS;
end;

procedure TRSDBNavigator.DataChanged;
var
  UpEnable, DnEnable: Boolean;
begin
  UpEnable := FDataSource.Active and not FDataSource.DataSet.BOF;
  DnEnable := FDataSource.Active and not FDataSource.DataSet.EOF;
  FButtons[btFirst].Enabled := UpEnable;
  FButtons[btPrev].Enabled := UpEnable;
  FButtons[btNext].Enabled := DnEnable;
  FButtons[btLast].Enabled := DnEnable;
  FButtons[btDel].Enabled := Enabled and FDataSource.Active and
    FDataSource.DataSet.CanModify and
    not (FDataSource.DataSet.BOF and FDataSource.DataSet.EOF);
end;

procedure TRSDBNavigator.EditingChanged;
var
  CanModify: Boolean;
begin
  CanModify := FDataSource.Active and FDataSource.DataSet.CanModify;
  FButtons[btAdd].Enabled := CanModify;
  FButtons[btEdit].Enabled := CanModify and not FDataSource.Editing;
  FButtons[btApply].Enabled := CanModify and FDataSource.Editing;
  FButtons[btCancel].Enabled := CanModify and FDataSource.Editing;
  FButtons[btRefresh].Enabled := CanModify;
end;

procedure TRSDBNavigator.ActiveChanged;
var
  I: TPropButton;
begin
  if not FDataSource.Active then
    for I := Low(FButtons) to High(FButtons) do
      FButtons[I].Enabled := False
  else
  begin
    DataChanged;
    EditingChanged;
  end;
end;

procedure TRSDBNavigator.CMEnabledChanged(var Message: TMessage);
begin
  inherited;
  if not (csLoading in ComponentState) then
    ActiveChanged;
end;

procedure TRSDBNavigator.Loaded;
begin
  inherited Loaded;
  UpdateCaptions;
  SetAutoSize (FASize);
  UpdateButtons;
  ActiveChanged;
end;

procedure TRSDBNavigator.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (FDataSource <> nil) and
    (AComponent = DataSource) then DataSource := nil;
end;

procedure TRSDBNavigator.SetNumGlyphs (Value: Integer);
Var
 Idx : TPropButton;
Begin
  FNumGlyphs:=Value;
  For idx:=Low(FButtons) to High(FButtons) do
   Begin
    FButtons[idx].NumGlyphs := FNumGlyphs;
   End;
End;

//////////////////////////// TRSNavDataLink
{ TRSNavDataLink }

constructor TRSNavDataLink.Create(ANav: TRSDBNavigator);
begin
  inherited Create;
  FNavigator := ANav;
  VisualControl := True;
end;

destructor TRSNavDataLink.Destroy;
begin
  FNavigator := nil;
  inherited Destroy;
end;

procedure TRSNavDataLink.EditingChanged;
begin
  if FNavigator <> nil then FNavigator.EditingChanged;
end;

procedure TRSNavDataLink.DataSetChanged;
begin
  if FNavigator <> nil then FNavigator.DataChanged;
end;

procedure TRSNavDataLink.ActiveChanged;
begin
  if FNavigator <> nil then FNavigator.ActiveChanged;
end;

end.

