{*******************************************************}
{                                                       }
{                      RSControls                       }
{                                                       }
{        Copyright (c) 2000, 2001 by RealSoft           }
{	 	    E-mail & http:			}
{          dclrs@realsoft2000.virtualave.net            }
{*******************************************************}
unit RSImage;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
  TRSImage = class(TImage)
  private
   FOnPicture: TPicture;
   FOffPicture: TPicture;
    { Private declarations }
  protected
   procedure SetOnPicture (Value: TPicture);
   procedure SetOffPicture (Value: TPicture);
   procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
   procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
    { Protected declarations }
  public
   constructor Create (AOwner: TComponent); override;
   destructor Destroy; override;
   procedure SetVisibleOff;
    { Public declarations }
  published
    { Published declarations }
    property OnPicture: TPicture read FOnPicture write SetOnPicture;
    property OffPicture: TPicture read FOffPicture write SetOffPicture;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('RS Control', [TRSImage]);
end;

constructor TRSImage.Create (AOwner: TComponent);
Begin
 inherited Create(AOwner);
 FOnPicture := TPicture.Create;
 FOffPicture := TPicture.Create;
End;

destructor TRSImage.Destroy;
Begin
 FOnPicture.Free;
 FOffPicture.Free;
 inherited Destroy;
End;

procedure TRSImage.SetOnPicture (Value: TPicture);
Begin
 FonPicture.Assign (Value);
End;

procedure TRSImage.SetOffPicture (Value: TPicture);
Begin
 FoffPicture.Assign (Value);
 Picture:=Value;
End;

procedure TRSImage.CMMouseEnter(var Message: TMessage);
Begin
 if Enabled and Visible then
  Picture:=FOnPicture;
End;

procedure TRSImage.CMMouseLeave(var Message: TMessage);
Begin
 if Enabled and Visible then
  Picture:=FOffPicture;
End;

procedure TRSImage.SetVisibleOff;
Begin
 Visible:=false;
 Picture:=FOffPicture;
end;

end.
